<?php

class UserModel {
  public $address_id = null;
  public $username = null;
  public $password = null;
  public $name = null;
  public $email = null;
  public $ip = null;
  public $sessionid = null;
  
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  
  public static function find($data) {
    
  }
  
  public static function create(Array $data) {
    $model = new User();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Worker", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new User($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Worker", "*", "1=1 ORDER BY address_id, username");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new User($data);
      }
    }
    return $items;
    
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $sql = "SELECT Worker.* FROM Worker, WorkerPermission
            WHERE WorkerPermission.worker_id = Worker.id
            AND $where
            GROUP BY WorkerPermission.worker_id
            ORDER BY address_id, username, Worker.id";
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new User($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    //var_dump($filter);exit;
    if(array_key_exists("address_id", $filter)) {
      $addressid = $filter['address_id'];
      if($addressid) {
        $where .= " AND address_id=$addressid";
      }
    }
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}